<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "SEO" - Search Engine Optimization and Analytics      |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 1.2b / November 2013 ==

*/

	function google_position($keyword, $url) 
	{ 
		$query = $keyword; 
		if (!$query) die("Kein Query"); 
		if ($url{(strlen($url))-1} == "/") $url = substr($url, 0, strlen($url)-1); 
		$query = rawurlencode($query); 

		$aufruf = "http://www.google.de/search?q=" . $query . "&num=100&start=0&ie=UTF-8&oe=UTF-8"; 
		$seiteninhalt=implode("", file($aufruf)); 

	//	echo htmlspecialchars($seiteninhalt, ENT_COMPAT, 'ISO-8859-15');

		preg_match_all('/<li([^>]*)class="g"([^>]*)>(.*?)<a([^>]*)href="\/url\?q=(.*?)([^>]*)>(.*?)<\/a>(.*?)<\/li>/is', $seiteninhalt, $ergebnis); 

		$ergebnisse = array(); 
		$positionen = array(); 
		$count = 0; 

		while($count < 100) 
		{ 
		$ergebnisse[] = array(
			"platz" => $count + 1, 
			"url" => $ergebnis[6][$count]
			); 


		$hurl = $ergebnis[6][$count]; 
		if ($hurl{(strlen($hurl))-1} == "/") $hurl = substr($hurl, 0, strlen($hurl)-1); 
		$positionen[] = substr($hurl,0,strlen($url)); 
		$count++; 
		} 

	//	print_r ($ergebnisse);
		$position = array_keys($positionen, $url); 
//		return $position[0]; 
		return (isset($position[0])) ? intval($position[0]) + 1 : '>100'; 
	//	return $seiteninhalt; 
	} 

	/**
	 * PageRank Lookup (Based on Google Toolbar for Mozilla Firefox)
	 *
	 * @copyright   2012 HM2K <hm2k@php.net>
	 * @link        http://pagerank.phurix.net/
	 * @author      James Wade <hm2k@php.net>
	 * @version     $Revision: 2.1 $
	 * @require     PHP 4.3.0 (file_get_contents)
	 * @updated		06/10/11
	 */

	function GetPageRank($q,$host='toolbarqueries.google.com',$context=NULL) {
		$seed = "Mining PageRank is AGAINST GOOGLE'S TERMS OF SERVICE. Yes, I'm talking to you, scammer.";
		$result = 0x01020345;
		$len = strlen($q);
		for ($i=0; $i<$len; $i++) {
			$result ^= ord($seed{$i%strlen($seed)}) ^ ord($q{$i});
			$result = (($result >> 23) & 0x1ff) | $result << 9;
		}
		if (PHP_INT_MAX != 2147483647) { $result = -(~($result & 0xFFFFFFFF) + 1); }
		$ch=sprintf('8%x', $result);
		$url='http://%s/tbr?client=navclient-auto&ch=%s&features=Rank&q=info:%s';
		$url=sprintf($url,$host,$ch,$q);
		@$pr=file_get_contents($url,false,$context);
		return $pr?substr(strrchr($pr, ':'), 1):'NV';
	}

// usage: mod_SEO.php?request=pagerank&site=http://WWW.DOMAIN.TLD
// usage: mod_SEO.php?request=position&keyword=SEARCHPHRASE&site=http:/WWW.DOMAIN.TLD

header('Content-Type: text/html; charset=utf-8'); // sorgt fr die korrekte Kodierung
header('Cache-Control: must-revalidate, pre-check=0, no-store, no-cache, max-age=0, post-check=0'); // ist mal wieder wichtig wegen IE

switch ($_POST['request']) {
	case 'pagerank':
		echo GetPageRank($_POST['site']);
		break;
	case 'position':
		echo google_position($_POST['keyword'], $_POST['site']);
		break;
	default:
		echo 'wrong request';
}
?>